/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
/*
 * Generated by Gas3 v2.3.0 (Granite Data Services).
 *
 * NOTE: this file is only generated if it does not exist. You may safely put
 * your custom code here.
 */

package org.ow2.orchestra.designer.bpmn.model.data {
import flash.utils.IDataInput;

import mx.collections.ArrayCollection;

import mx.events.CollectionEvent;
import mx.events.CollectionEventKind;

import org.ow2.orchestra.designer.bpmn.model.AbstractElement;
import org.ow2.orchestra.designer.bpmn.model.AbstractElementWithPosition;
import org.ow2.orchestra.designer.bpmn.model.FlowModel;

[Bindable]
[RemoteClass(alias="org.ow2.orchestra.designer.bpmn.model.data.DataMappingModel")]
public class DataMappingModel extends DataMappingModelBase {
  public function DataMappingModel() {
    super();
    elements.addEventListener(CollectionEvent.COLLECTION_CHANGE, elementsModified);
  }

  // Add event listener for elements changes
  public override function readExternal(input:IDataInput):void {
    super.readExternal(input);
    elements.addEventListener(CollectionEvent.COLLECTION_CHANGE, elementsModified);
    for each (var element:AbstractElement in elements) {
      element.onDeserializationComplete();
    }
  }

  /**
   * Listener for process element changes.
   * Deletes sequence flow when the source or target element is removed.
   * @param collectionEvent
   */
  public function elementsModified(collectionEvent:CollectionEvent):void {
    // model elements changed.
    var changedElements:Array = collectionEvent.items;
    if (collectionEvent.kind == CollectionEventKind.REMOVE) {
      for each (var removedElement:Object in changedElements) {
        if (removedElement is AbstractElementWithPosition) {
          // remove sequenceFlow elements attached to the element to delete
          // iterate on a copy of the elements list to avoid concurrent modifications
          // (sequenceFlow are removed from the elements list)
          var elementsCopy:ArrayCollection = new ArrayCollection();
          elementsCopy.addAll(elements);
          for each (var element:Object in elementsCopy) {
            if (element is FlowModel) {
              var sequenceFlowModel:FlowModel = element as FlowModel;
              if (sequenceFlowModel.sourceElement == removedElement || sequenceFlowModel.targetElement == removedElement) {
                // remove sequence flow
                elements.removeItemAt(elements.getItemIndex(sequenceFlowModel));
              }
            }
          }
        } else if (removedElement is FlowModel) {
          var removedSequenceFlowModel:FlowModel = removedElement as FlowModel;
          // Remove from old source outgoing sequence flows list
          var oldSource:AbstractElementWithPosition = removedSequenceFlowModel.sourceElement;
          if (oldSource != null) {
            var srcIndex:int = oldSource.outgoingFlows.getItemIndex(removedSequenceFlowModel);
            if (srcIndex != -1) {
              oldSource.outgoingFlows.removeItemAt(srcIndex);
            }
          }
          // Remove from old target incoming sequence flows list
          var oldTarget:AbstractElementWithPosition = removedSequenceFlowModel.targetElement;
          if (oldTarget != null) {
            var targetIndex:int = oldTarget.incomingFlows.getItemIndex(removedSequenceFlowModel);
            if (targetIndex != -1) {
              oldTarget.incomingFlows.removeItemAt(targetIndex);
            }
          }
        }
      }
    }
  }

}
}
