/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
/*
 * Generated by Gas3 v2.2.0 (Granite Data Services).
 *
 * NOTE: this file is only generated if it does not exist. You may safely put
 * your custom code here.
 */

package org.ow2.orchestra.designer.bpmn.model.process {
import flash.events.Event;
import flash.utils.IDataInput;

import mx.collections.ArrayCollection;
import mx.events.PropertyChangeEvent;

import org.ow2.orchestra.designer.bpmn.model.data.DataInputModel;
import org.ow2.orchestra.designer.bpmn.model.data.DataObjectModel;
import org.ow2.orchestra.designer.bpmn.model.data.type.WSDLMessageModel;
import org.ow2.orchestra.designer.bpmn.model.data.type.WSDLMessagePartModel;
import org.ow2.orchestra.designer.bpmn.model.operations.InterfaceModel;
import org.ow2.orchestra.designer.bpmn.model.operations.OperationModel;
import org.ow2.orchestra.designer.bpmn.model.utils.IDUtil;

[Bindable]
[RemoteClass(alias="org.ow2.orchestra.designer.bpmn.model.process.EventModel")]
public class EventModel extends EventModelBase {
  public function EventModel() {
    super();
    this.eventType = EventType.NONE;
  }


  override public function readExternal(input:IDataInput):void {
    super.readExternal(input);
    if (operation != null) {
      if (eventType == EventType.RECEIVE_MESSAGE) {
        operation.receiveElements.addItem(this);
        operation.inMessageType.addEventListener(PropertyChangeEvent.PROPERTY_CHANGE, refreshDataObjects);
      } else if (eventType == EventType.SEND_MESSAGE) {
        operation.outMessageType.addEventListener(PropertyChangeEvent.PROPERTY_CHANGE, getDataInputs);
      }
    }
  }

  public override function set name(value:String):void {
    var oldName:String = name;
    super.name = value;
    if (eventType == EventType.RECEIVE_MESSAGE) {
      if (operation.interfaceModel.name == oldName + "Interface") {
        interfaceName = value + "Interface";
      }
      if (operation.name == oldName + "Operation") {
        operationName = value + "Operation";
      }
    }
    if (variableName == oldName + "Data") {
      variableName = value + "Data";
    }
  }

  public override function set eventType(value:EventType):void {
    if (value != eventType) {
      super.eventType = value;
      if (value == EventType.RECEIVE_MESSAGE) {
        // reset default interface (sets default operation name)
        setDefaultOperation();
      } else {
        operation = null;
        // choose the first interface/operation for default value
        if (this.processModel != null && this.processModel.interfaces != null && this.processModel.interfaces.length >= 1) {
          var operations:ArrayCollection = (this.processModel.interfaces.values.getItemAt(0) as InterfaceModel).operations.values;
          if (operations.length >= 1) {
            operation = operations.getItemAt(0) as OperationModel;
          }
        }
        if (value == EventType.TIMER) {
          // Default timer to 5 sec
          this.timerDuration = "\"PT5S\"";
        }
      }
    }
  }


  public override function set operation(value:OperationModel):void {
    if (operation != null) {
      var index:int = operation.receiveElements.getItemIndex(this);
      if (index >= 0) {
        operation.receiveElements.removeItemAt(index);
      }
      index = operation.sendElements.getItemIndex(this);
      if (index >= 0) {
        operation.sendElements.removeItemAt(index);
      }
      operation.inMessageType.removeEventListener(PropertyChangeEvent.PROPERTY_CHANGE, refreshDataObjects);
      if (operation.outMessageType != null) {
        operation.outMessageType.removeEventListener(PropertyChangeEvent.PROPERTY_CHANGE, getDataInputs);
      }

    }
    this.dataInputs.removeAll();
    var oldVarName:String = this.variableName;
    this.variableName = null;
    super.operation = value;
    if (value != null) {
      if (eventType == EventType.RECEIVE_MESSAGE) {
        value.receiveElements.addItem(this);
        value.inMessageType.addEventListener(PropertyChangeEvent.PROPERTY_CHANGE, refreshDataObjects);
        this.variableName = oldVarName;
      } else if (eventType == EventType.SEND_MESSAGE) {
        value.sendElements.addItem(this);
        value.outMessageType.addEventListener(PropertyChangeEvent.PROPERTY_CHANGE, getDataInputs);
        getDataInputs();
      }
    }
  }

  protected function refreshDataObjects(event:Event = null):void {
    getDataObjects(this.variableName);
  }

  protected function getDataObjects(value:String):void {
    // Remove old variables
    if (this.outputVariables.length != 0) {
      for each (var outputVariable:DataObjectModel in this.outputVariables) {
        var index:int = outputVariable.usedBy.getItemIndex(this);
        if (index != -1) {
          outputVariable.usedBy.removeItemAt(index);
        }
      }
      this.outputVariables.removeAll();
    }
    if (value != null && value != "" && processModel != null && this.operation != null) {
      var messageModel:WSDLMessageModel = this.operation.inMessageType as WSDLMessageModel;
      for each (var messagePartModel:WSDLMessagePartModel in messageModel.parts) {
        var variableName:String;
        if (messageModel.parts.length > 1) {
          variableName = value + " " + messagePartModel.partName;
        } else {
          variableName = value;
        }
        var variable:DataObjectModel = this.processModel.dataObjects.get(variableName);
        if (variable == null) {
          variable = new DataObjectModel();
          variable.name = variableName;
          variable.id = IDUtil.generateId();
          this.processModel.dataObjects.put(variableName, variable);
          variable.processModel = this.processModel;
        }
        if (messagePartModel.xsdType != null) {
          variable.type = messagePartModel.xsdType;
        } else {
          variable.type = messagePartModel.xsdElement;
        }
        variable.usedBy.addItem(this);
        this.outputVariables.addItem(variable);
      }
    }
  }

  protected function getDataInputs(event:Event = null):void {
    var messageModel:WSDLMessageModel = operation.outMessageType as WSDLMessageModel;
    this.dataInputs.removeAll();
    for each (var partModel:WSDLMessagePartModel in messageModel.parts) {
      var dataInputModel:DataInputModel = new DataInputModel();
      dataInputModel.id = IDUtil.generateId();
      dataInputModel.name = partModel.partName;
      if (partModel.xsdType != null) {
        dataInputModel.type = partModel.xsdType;
      } else {
        dataInputModel.type = partModel.xsdElement;
      }
      this.dataInputs.addItem(dataInputModel);
    }
  }

  public function set operationName(operationName:String):void {
    var iface:InterfaceModel = operation.interfaceModel;
    var newOperation:OperationModel = iface.operations.get(operationName);
    if (newOperation == null) {
      newOperation = new OperationModel();
      newOperation.id = IDUtil.generateId();
      newOperation.name = operationName;
      newOperation.interfaceModel = iface;

      iface.operations.put(operationName, newOperation);
    }
    this.operation = newOperation;
  }

  public function set interfaceName(interfaceName:String):void {
    var operationName:String;
    if (operation != null) {
      operationName = operation.name;
    } else {
      operationName = interfaceName + "DefaultOperation";
    }
    var iface:InterfaceModel = processModel.interfaces.get(interfaceName);
    if (iface == null) {
      iface = new InterfaceModel();
      iface.id = IDUtil.generateId();
      iface.name = interfaceName;
      iface.poolModel = processModel;
      processModel.interfaces.put(interfaceName, iface);
    }
    var newOperation:OperationModel = iface.operations.get(operationName);
    if (newOperation == null) {
      newOperation = new OperationModel();
      newOperation.id = IDUtil.generateId();
      newOperation.name = operationName;
      newOperation.interfaceModel = iface;
      iface.operations.put(operationName, newOperation);
    }
    this.operation = newOperation;
  }

  private function setDefaultOperation():void {
    interfaceName = name + "Interface";
    operationName = name + "Operation";
    variableName = name + "Data";
  }

  public function set variableName(value:String):void {
    getDataObjects(value);
  }


  public function get variableName():String {
    if (this.outputVariables.length == 0) {
      return "";
    }
    if (this.outputVariables.length == 1) {
      return (this.outputVariables.getItemAt(0) as DataObjectModel).name;
    }
    var completeName:String = (this.outputVariables.getItemAt(0) as DataObjectModel).name;
    var index:int = completeName.lastIndexOf(' ');
    return completeName.substring(0, index);
  }
}
}
