/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
/*
 * Generated by Gas3 v2.2.0 (Granite Data Services).
 *
 * NOTE: this file is only generated if it does not exist. You may safely put
 * your custom code here.
 */

package org.ow2.orchestra.designer.bpmn.model.process {
import flash.events.Event;

import mx.binding.utils.ChangeWatcher;
import mx.events.CollectionEvent;

import org.ow2.orchestra.designer.FlexQName;
import org.ow2.orchestra.designer.bpmn.model.AbstractElement;
import org.ow2.orchestra.designer.bpmn.model.AbstractElementWithPosition;
import org.ow2.orchestra.designer.bpmn.model.data.DataInputModel;
import org.ow2.orchestra.designer.bpmn.model.data.DataMappingModel;
import org.ow2.orchestra.designer.bpmn.model.data.ExpressionDataInputModel;
import org.ow2.orchestra.designer.bpmn.model.data.type.XSDSimpleType;
import org.ow2.orchestra.designer.bpmn.model.utils.IDUtil;

[Bindable]
[RemoteClass(alias="org.ow2.orchestra.designer.bpmn.model.process.SequenceFlowModel")]
public class SequenceFlowModel extends SequenceFlowModelBase {

  private var changeWatcher:ChangeWatcher;

  public function SequenceFlowModel() {
    super();
    generateDataInput();
    this.dataMappingModel = new DataMappingModel();
    this.dataMappingModel.elements.addEventListener(
            CollectionEvent.COLLECTION_CHANGE, checkHasCondition);
  }

  private function checkHasCondition(event:CollectionEvent):void {
    var res:Boolean = false;
    for each (var elt:AbstractElement in dataMappingModel.elements) {
      if (elt is ExpressionDataInputModel) {
        res = true;
      }
    }
    this.hasCondition = res;
  }


  private function generateDataInput():void {
    var dataInputModel:DataInputModel = new DataInputModel();
    dataInputModel.id = IDUtil.generateId();
    dataInputModel.name = "condition";
    var booleanType:XSDSimpleType = new XSDSimpleType();
    booleanType.QName = FlexQName.valueOf("{http://www.w3.org/2001/XMLSchema}boolean");
    booleanType.id = IDUtil.generateId();
    dataInputModel.type = booleanType;
    this.dataInputs.addItem(dataInputModel);
  }

  public override function onDeserializationComplete():void {
    if (sourceElement != null) {
      changeWatcher = ChangeWatcher.watch(sourceElement, "gatewayType", checkExclusiveGateway);
      sourceElement.outgoingFlows.addEventListener(CollectionEvent.COLLECTION_CHANGE, checkExclusiveGateway);
    }
    if (dataInputs.length == 0) {
      generateDataInput();
    }
    if (this.dataMappingModel == null) {
      this.dataMappingModel = new DataMappingModel();
    }
    this.dataMappingModel.elements.addEventListener(
            CollectionEvent.COLLECTION_CHANGE, checkHasCondition);
  }


  public override function set sourceElement(newSource:AbstractElementWithPosition):void {
    // Change sequence flow source
    // Remove from old source outgoing sequence flows list
    var oldSource:AbstractElementWithPosition = this.sourceElement;
    if (oldSource != null) {
      if (changeWatcher == null) {
        changeWatcher.unwatch();
      }
      oldSource.outgoingFlows.removeEventListener(CollectionEvent.COLLECTION_CHANGE, checkExclusiveGateway);
    }
    // Add to new source outgoing sequence flows list
    if (newSource != null) {
      newSource.outgoingFlows.addEventListener(CollectionEvent.COLLECTION_CHANGE, checkExclusiveGateway);
      if (changeWatcher == null) {
        changeWatcher = ChangeWatcher.watch(sourceElement, "gatewayType", checkExclusiveGateway);
      } else {
        changeWatcher.reset(newSource);
      }
    }
    // update sourceElement
    super.sourceElement = newSource;
  }

  /**
   * If sourceElement is not an exclusive gateway, condition should be set to null
   * If sourceElement is an exclusive gateway, determine if this sequenceFlow si the default sequenceFlow.
   */
  private function checkExclusiveGateway(event:Event = null):void {
    if ((sourceElement is GatewayModel) && (sourceElement as GatewayModel).gatewayType == GatewayType.EXCLUSIVE) {
      if (sourceElement.outgoingFlows.length > 1 && !hasCondition) {
        var isDef:Boolean = true;
        for each(var seq:SequenceFlowModel in sourceElement.outgoingFlows) {
          if (seq != this && !seq.hasCondition) {
            isDef = false;
          }
        }
        this.isDefault = isDef;
      } else {
        this.isDefault = false;
      }
    } else {
      this.hasCondition = false;
      this.dataMappingModel.elements.removeAll();
      this.isDefault = false;
    }
  }
}

}
