/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
/*
 * Generated by Gas3 v2.2.0 (Granite Data Services).
 *
 * NOTE: this file is only generated if it does not exist. You may safely put
 * your custom code here.
 */

package org.ow2.orchestra.designer.bpmn.model.process {
import org.ow2.orchestra.designer.bpmn.model.data.DataInputModel;
import org.ow2.orchestra.designer.bpmn.model.data.DataObjectModel;
import org.ow2.orchestra.designer.bpmn.model.data.type.WSDLMessageModel;
import org.ow2.orchestra.designer.bpmn.model.data.type.WSDLMessagePartModel;
import org.ow2.orchestra.designer.bpmn.model.operations.InterfaceModel;
import org.ow2.orchestra.designer.bpmn.model.operations.OperationModel;
import org.ow2.orchestra.designer.bpmn.model.utils.IDUtil;

[Bindable]
[RemoteClass(alias="org.ow2.orchestra.designer.bpmn.model.process.TaskModel")]
public class TaskModel extends TaskModelBase {
  public function TaskModel() {
    super();
    this.taskType = TaskType.SERVICE;
  }

  public override function set name(value:String):void {
    var oldName:String = name;
    super.name = value;
    if (taskType == TaskType.SERVICE || taskType == TaskType.USER) {
      if ((taskType == TaskType.USER
              || (operation != null && operation.outMessageType != null))
              && (outputVariableName == null || outputVariableName == oldName + "Data")) {
        outputVariableName = value + "Data";
      }
      if (taskType == TaskType.USER) {
        this.potentialOwnerExpression = "\"orchestra\"";
      }
    }
  }

  public override function set taskType(value:TaskType):void {
    if (value != taskType) {
      super.taskType = value;
      if (taskType != TaskType.SERVICE) {
        this.operation = null;
      }
      if (taskType == TaskType.USER) {
        this.operation = getDefaultOperation();
        this.outputVariableName = name + "Data";
        this.potentialOwnerExpression = "\"orchestra\"";
      }
    }
  }

  private function getDefaultOperation():OperationModel {
    var interfaceName:String = "taskPT" + id;
    var operationName:String = "taskOperation";
    var iface:InterfaceModel = processModel.interfaces.get(interfaceName);
    if (iface == null) {
      iface = new InterfaceModel();
      iface.id = IDUtil.generateId();
      iface.name = interfaceName;
      iface.poolModel = processModel;
      processModel.interfaces.put(interfaceName, iface);
    }
    var newOperation:OperationModel = iface.operations.get(operationName);
    if (newOperation == null) {
      newOperation = new OperationModel();
      newOperation.id = IDUtil.generateId();
      newOperation.name = operationName;
      newOperation.interfaceModel = iface;
      iface.operations.put(operationName, newOperation);
    }
    return newOperation;
  }


  public override function set operation(value:OperationModel):void {
    if (operation != null) {
      var index:int = operation.receiveElements.getItemIndex(this);
      if (index >= 0) {
        operation.receiveElements.removeItemAt(index);
      }
      index = operation.sendElements.getItemIndex(this);
      if (index >= 0) {
        operation.sendElements.removeItemAt(index);
      }
    }
    this.dataInputs.removeAll();
    super.operation = value;
    if (value != null && (taskType == TaskType.SERVICE || taskType == TaskType.USER)) {
      if (taskType == TaskType.USER) {
        value.receiveElements.addItem(this);
        value.sendElements.addItem(this);
      }
      var messageModel:WSDLMessageModel = value.inMessageType as WSDLMessageModel;
      for each (var partModel:WSDLMessagePartModel in messageModel.parts) {
        var dataInputModel:DataInputModel = new DataInputModel();
        dataInputModel.id = IDUtil.generateId();
        dataInputModel.name = partModel.partName;
        if (partModel.xsdType != null) {
          dataInputModel.type = partModel.xsdType;
        } else {
          dataInputModel.type = partModel.xsdElement;
        }
        this.dataInputs.addItem(dataInputModel);
      }
      if (value.outMessageType != null) {
        if (this.outputVariableName == "") {
          this.outputVariableName = name + "Data";
        } else {
          // reset dataObject to reflect the new operation message parts.
          this.outputVariableName = this.outputVariableName;
        }
      } else {
        this.outputVariableName = null;
      }
    }
  }

  public function set outputVariableName(value:String):void {
    // Remove old variables
    if (this.outputVariables.length != 0) {
      for each (var outputVariable:DataObjectModel in this.outputVariables) {
        var index:int = outputVariable.usedBy.getItemIndex(this);
        if (index != -1) {
          outputVariable.usedBy.removeItemAt(index);
        }
      }
      this.outputVariables.removeAll();
    }
    if (value != null && value != "" && processModel != null && this.operation != null && this.operation.outMessageType != null) {
      var messageModel:WSDLMessageModel = this.operation.outMessageType as WSDLMessageModel;
      for each (var messagePartModel:WSDLMessagePartModel in messageModel.parts) {
        var variableName:String;
        if (messageModel.parts.length > 1) {
          variableName = value + " " + messagePartModel.partName;
        } else {
          variableName = value;
        }
        var variable:DataObjectModel = this.processModel.dataObjects.get(variableName);
        if (variable == null) {
          variable = new DataObjectModel();
          variable.name = variableName;
          variable.id = IDUtil.generateId();
          if (messagePartModel.xsdType != null) {
            variable.type = messagePartModel.xsdType;
          } else {
            variable.type = messagePartModel.xsdElement;
          }
          this.processModel.dataObjects.put(variableName, variable);
          variable.processModel = this.processModel;
        }
        variable.usedBy.addItem(this);
        this.outputVariables.addItem(variable);
      }
    }
  }

  public function get outputVariableName():String {
    if (this.outputVariables.length == 0) {
      return "";
    }
    if (this.outputVariables.length == 1) {
      return (this.outputVariables.getItemAt(0) as DataObjectModel).name;
    }
    var completeName:String = (this.outputVariables.getItemAt(0) as DataObjectModel).name;
    var index:int = completeName.lastIndexOf(' ');
    return completeName.substring(0, index);
  }
}
}
